--- a/ext/zip/php_zip.c	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/zip/php_zip.c	2025-11-18 21:43:27.195227947 +0000
@@ -1838,6 +1838,11 @@
 				}
 #ifdef HAVE_ENCRYPTION
 				if (opts.enc_method >= 0) {
+					if (UNEXPECTED(zip_file_set_encryption(ze_obj->za, ze_obj->last_id, ZIP_EM_NONE, NULL) < 0)) {
+						zend_array_destroy(Z_ARR_P(return_value));
+						php_error_docref(NULL, E_WARNING, "password reset failed");
+						RETURN_FALSE;
+					}
 					if (zip_file_set_encryption(ze_obj->za, ze_obj->last_id, opts.enc_method, opts.enc_password)) {
 						zend_array_destroy(Z_ARR_P(return_value));
 						RETURN_FALSE;
diff '--color=auto' -Naur a/ext/zip/tests/oo_addglob_leak.phpt b/ext/zip/tests/oo_addglob_leak.phpt
--- a/ext/zip/tests/oo_addglob_leak.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/zip/tests/oo_addglob_leak.phpt	2025-11-18 21:43:27.195566281 +0000
@@ -0,0 +1,51 @@
+--TEST--
+ZipArchive::addGlob() method leaking after several calls when encryption is set.
+--EXTENSIONS--
+zip
+--SKIPIF--
+<?php
+if (!method_exists('ZipArchive', 'setEncryptionName')) die('skip encrytion not supported');
+if(!defined("GLOB_BRACE")) die ('skip requires GLOB_BRACE');
+?>
+--FILE--
+<?php
+$dirname = __DIR__ . '/';
+include $dirname . 'utils.inc';
+
+$dirname = __DIR__ . '/__tmp_oo_addglob2/';
+$file = $dirname . 'test.zip';
+
+@mkdir($dirname);
+copy(__FILE__, $dirname . 'foo.txt');
+copy(__FILE__, $dirname . 'bar.txt');
+
+$zip = new ZipArchive();
+if (!$zip->open($file, ZipArchive::CREATE | ZipArchive::OVERWRITE)) {
+        exit('failed');
+}
+
+$options = [
+    'remove_all_path' => true,
+    'comp_method' => ZipArchive::CM_STORE,
+    'comp_flags' => 5,
+    'enc_method' => ZipArchive::EM_AES_256,
+    'enc_password' => 'secret',
+];
+var_dump($zip->addGlob($dirname . 'bar.*', GLOB_BRACE, $options));
+var_dump($zip->addGlob($dirname . 'bar.*', GLOB_BRACE, $options));
+?>
+--CLEAN--
+<?php
+$dirname = __DIR__ . '/';
+include $dirname . 'utils.inc';
+rmdir_rf(__DIR__ . '/__tmp_oo_addglob2/');
+?>
+--EXPECTF--
+array(1) {
+  [0]=>
+  string(%d) "%s"
+}
+array(1) {
+  [0]=>
+  string(%d) "%s"
+}
diff '--color=auto' -Naur a/ext/zlib/tests/zlib_wrapper_flock_basic.phpt b/ext/zlib/tests/zlib_wrapper_flock_basic.phpt
--- a/ext/zlib/tests/zlib_wrapper_flock_basic.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/ext/zlib/tests/zlib_wrapper_flock_basic.phpt	2025-11-18 21:43:27.196526459 +0000
@@ -4,7 +4,7 @@
 zlib
 --FILE--
 <?php
-$f = __DIR__."/004.txt.gz";
+$f = __DIR__."/zlib_flock.txt.gz";
 $h = gzopen($f,'r');
 var_dump(flock($h, LOCK_SH));
 gzclose($h);
diff '--color=auto' -Naur a/main/php_version.h b/main/php_version.h
--- a/main/php_version.h	2025-10-21 19:23:55.000000000 +0000
+++ b/main/php_version.h	2025-11-18 21:47:41.919656895 +0000
@@ -2,7 +2,7 @@
 /* edit configure.ac to change version number */
 #define PHP_MAJOR_VERSION 8
 #define PHP_MINOR_VERSION 4
-#define PHP_RELEASE_VERSION 14
+#define PHP_RELEASE_VERSION 15
 #define PHP_EXTRA_VERSION ""
-#define PHP_VERSION "8.4.14"
-#define PHP_VERSION_ID 80414
+#define PHP_VERSION "8.4.15"
+#define PHP_VERSION_ID 80415
diff '--color=auto' -Naur a/main/php_version.h.orig b/main/php_version.h.orig
--- a/main/streams/xp_socket.c	2025-10-21 19:23:55.000000000 +0000
+++ b/main/streams/xp_socket.c	2025-11-18 21:43:27.196881930 +0000
@@ -858,7 +858,7 @@
 static inline int php_tcp_sockop_accept(php_stream *stream, php_netstream_data_t *sock,
 		php_stream_xport_param *xparam STREAMS_DC)
 {
-	int clisock;
+	php_socket_t clisock;
 	bool nodelay = 0;
 	zval *tmpzval = NULL;
 
@@ -879,7 +879,7 @@
 		&xparam->outputs.error_code,
 		nodelay);
 
-	if (clisock >= 0) {
+	if (clisock != SOCK_ERR) {
 		php_netstream_data_t *clisockdata = (php_netstream_data_t*) emalloc(sizeof(*clisockdata));
 
 		memcpy(clisockdata, sock, sizeof(*clisockdata));
diff '--color=auto' -Naur a/run-tests.php b/run-tests.php
--- a/run-tests.php	2025-10-21 19:23:55.000000000 +0000
+++ b/run-tests.php	2025-11-18 21:43:27.197566307 +0000
@@ -2805,6 +2805,11 @@
     if ($test->hasSection('FLAKY')) {
         return true;
     }
+    if ($test->hasSection('SKIPIF')) {
+        if (strpos($test->getSection('SKIPIF'), 'SKIP_PERF_SENSITIVE') !== false) {
+            return true;
+        }
+    }
     if (!$test->hasSection('FILE')) {
         return false;
     }
diff '--color=auto' -Naur a/sapi/cgi/tests/auto_globals_no_jit.phpt b/sapi/cgi/tests/auto_globals_no_jit.phpt
--- a/sapi/cgi/tests/auto_globals_no_jit.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/sapi/cgi/tests/auto_globals_no_jit.phpt	2025-11-18 21:43:27.198756299 +0000
@@ -0,0 +1,18 @@
+--TEST--
+CGI with auto_globals_jit=0
+--INI--
+auto_globals_jit=0
+variables_order="EGPCS"
+--CGI--
+--ENV--
+FOO=BAR
+--FILE--
+<?php
+var_dump($_SERVER['FOO']);
+var_dump($_ENV['FOO']);
+var_dump(getenv('FOO'));
+?>
+--EXPECT--
+string(3) "BAR"
+string(3) "BAR"
+string(3) "BAR"
diff '--color=auto' -Naur a/sapi/fpm/fpm/fpm_status.c b/sapi/fpm/fpm/fpm_status.c
--- a/sapi/fpm/fpm/fpm_status.c	2025-10-21 19:23:55.000000000 +0000
+++ b/sapi/fpm/fpm/fpm_status.c	2025-11-18 21:43:27.198892746 +0000
@@ -47,93 +47,76 @@
 
 int fpm_status_export_to_zval(zval *status)
 {
-	struct fpm_scoreboard_s scoreboard, *scoreboard_p;
+	struct fpm_scoreboard_s *scoreboard_p;
+	struct fpm_scoreboard_proc_s *proc_p;
 	zval fpm_proc_stats, fpm_proc_stat;
 	time_t now_epoch;
 	struct timeval duration, now;
 	double cpu;
 	int i;
 
-	scoreboard_p = fpm_scoreboard_acquire(NULL, 1);
-	if (!scoreboard_p) {
-		zlog(ZLOG_NOTICE, "[pool (unknown)] status: scoreboard already in use.");
-		return -1;
-	}
-
-	/* copy the scoreboard not to bother other processes */
-	scoreboard = *scoreboard_p;
-	struct fpm_scoreboard_proc_s *procs = safe_emalloc(
-			sizeof(struct fpm_scoreboard_proc_s), scoreboard.nprocs, 0);
-
-	struct fpm_scoreboard_proc_s *proc_p;
-	for(i=0; i<scoreboard.nprocs; i++) {
-		proc_p = fpm_scoreboard_proc_acquire(scoreboard_p, i, 1);
-		if (!proc_p){
-			procs[i].used=-1;
-			continue;
-		}
-		procs[i] = *proc_p;
-		fpm_scoreboard_proc_release(proc_p);
-	}
-	fpm_scoreboard_release(scoreboard_p);
+	scoreboard_p = fpm_scoreboard_copy(NULL, 1);
 
 	now_epoch = time(NULL);
 	fpm_clock_get(&now);
 
 	array_init(status);
-	add_assoc_string(status, "pool", scoreboard.pool);
-	add_assoc_string(status, "process-manager", PM2STR(scoreboard.pm));
-	add_assoc_long(status, "start-time", scoreboard.start_epoch);
-	add_assoc_long(status, "start-since", now_epoch - scoreboard.start_epoch);
-	add_assoc_long(status, "accepted-conn", scoreboard.requests);
-	add_assoc_long(status, "listen-queue", scoreboard.lq);
-	add_assoc_long(status, "max-listen-queue", scoreboard.lq_max);
-	add_assoc_long(status, "listen-queue-len", scoreboard.lq_len);
-	add_assoc_long(status, "idle-processes", scoreboard.idle);
-	add_assoc_long(status, "active-processes", scoreboard.active);
-	add_assoc_long(status, "total-processes", scoreboard.idle + scoreboard.active);
-	add_assoc_long(status, "max-active-processes", scoreboard.active_max);
-	add_assoc_long(status, "max-children-reached", scoreboard.max_children_reached);
-	add_assoc_long(status, "slow-requests", scoreboard.slow_rq);
-	add_assoc_long(status, "memory-peak", scoreboard.memory_peak);
+	add_assoc_string(status, "pool",  scoreboard_p->pool);
+	add_assoc_string(status, "process-manager", PM2STR( scoreboard_p->pm));
+	add_assoc_long(status, "start-time",  scoreboard_p->start_epoch);
+	add_assoc_long(status, "start-since", now_epoch -  scoreboard_p->start_epoch);
+	add_assoc_long(status, "accepted-conn",  scoreboard_p->requests);
+	add_assoc_long(status, "listen-queue",  scoreboard_p->lq);
+	add_assoc_long(status, "max-listen-queue",  scoreboard_p->lq_max);
+	add_assoc_long(status, "listen-queue-len",  scoreboard_p->lq_len);
+	add_assoc_long(status, "idle-processes",  scoreboard_p->idle);
+	add_assoc_long(status, "active-processes",  scoreboard_p->active);
+	add_assoc_long(status, "total-processes",  scoreboard_p->idle +  scoreboard_p->active);
+	add_assoc_long(status, "max-active-processes",  scoreboard_p->active_max);
+	add_assoc_long(status, "max-children-reached",  scoreboard_p->max_children_reached);
+	add_assoc_long(status, "slow-requests",  scoreboard_p->slow_rq);
+	add_assoc_long(status, "memory-peak",  scoreboard_p->memory_peak);
 
 	array_init(&fpm_proc_stats);
-	for(i=0; i<scoreboard.nprocs; i++) {
-		if (!procs[i].used) {
+	for(i = 0; i < scoreboard_p->nprocs; i++) {
+		proc_p = &scoreboard_p->procs[i];
+		if (!proc_p->used) {
 			continue;
 		}
-		proc_p = &procs[i];
 		/* prevent NaN */
-		if (procs[i].cpu_duration.tv_sec == 0 && procs[i].cpu_duration.tv_usec == 0) {
+		if (proc_p->cpu_duration.tv_sec == 0 && proc_p->cpu_duration.tv_usec == 0) {
 			cpu = 0.;
 		} else {
-			cpu = (procs[i].last_request_cpu.tms_utime + procs[i].last_request_cpu.tms_stime + procs[i].last_request_cpu.tms_cutime + procs[i].last_request_cpu.tms_cstime) / fpm_scoreboard_get_tick() / (procs[i].cpu_duration.tv_sec + procs[i].cpu_duration.tv_usec / 1000000.) * 100.;
+			cpu = (proc_p->last_request_cpu.tms_utime + proc_p->last_request_cpu.tms_stime + proc_p->last_request_cpu.tms_cutime +
+					proc_p->last_request_cpu.tms_cstime) / fpm_scoreboard_get_tick() /
+					(proc_p->cpu_duration.tv_sec + proc_p->cpu_duration.tv_usec / 1000000.) * 100.;
 		}
 
 		array_init(&fpm_proc_stat);
-		add_assoc_long(&fpm_proc_stat, "pid", procs[i].pid);
-		add_assoc_string(&fpm_proc_stat, "state", fpm_request_get_stage_name(procs[i].request_stage));
-		add_assoc_long(&fpm_proc_stat, "start-time", procs[i].start_epoch);
-		add_assoc_long(&fpm_proc_stat, "start-since", now_epoch - procs[i].start_epoch);
-		add_assoc_long(&fpm_proc_stat, "requests", procs[i].requests);
-		if (procs[i].request_stage == FPM_REQUEST_ACCEPTING) {
-			duration = procs[i].duration;
+		add_assoc_long(&fpm_proc_stat, "pid", proc_p->pid);
+		add_assoc_string(&fpm_proc_stat, "state", fpm_request_get_stage_name(proc_p->request_stage));
+		add_assoc_long(&fpm_proc_stat, "start-time", proc_p->start_epoch);
+		add_assoc_long(&fpm_proc_stat, "start-since", now_epoch - proc_p->start_epoch);
+		add_assoc_long(&fpm_proc_stat, "requests", proc_p->requests);
+		if (proc_p->request_stage == FPM_REQUEST_ACCEPTING) {
+			duration = proc_p->duration;
 		} else {
-			timersub(&now, &procs[i].accepted, &duration);
+			timersub(&now, &proc_p->accepted, &duration);
 		}
 		add_assoc_long(&fpm_proc_stat, "request-duration", duration.tv_sec * 1000000UL + duration.tv_usec);
-		add_assoc_string(&fpm_proc_stat, "request-method", procs[i].request_method[0] != '\0' ? procs[i].request_method : "-");
-		add_assoc_string(&fpm_proc_stat, "request-uri", procs[i].request_uri);
-		add_assoc_string(&fpm_proc_stat, "query-string", procs[i].query_string);
-		add_assoc_long(&fpm_proc_stat, "request-length", procs[i].content_length);
-		add_assoc_string(&fpm_proc_stat, "user", procs[i].auth_user[0] != '\0' ? procs[i].auth_user : "-");
-		add_assoc_string(&fpm_proc_stat, "script", procs[i].script_filename[0] != '\0' ? procs[i].script_filename : "-");
-		add_assoc_double(&fpm_proc_stat, "last-request-cpu", procs[i].request_stage == FPM_REQUEST_ACCEPTING ? cpu : 0.);
-		add_assoc_long(&fpm_proc_stat, "last-request-memory", procs[i].request_stage == FPM_REQUEST_ACCEPTING ? procs[i].memory : 0);
+		add_assoc_string(&fpm_proc_stat, "request-method", proc_p->request_method[0] != '\0' ? proc_p->request_method : "-");
+		add_assoc_string(&fpm_proc_stat, "request-uri", proc_p->request_uri);
+		add_assoc_string(&fpm_proc_stat, "query-string", proc_p->query_string);
+		add_assoc_long(&fpm_proc_stat, "request-length", proc_p->content_length);
+		add_assoc_string(&fpm_proc_stat, "user", proc_p->auth_user[0] != '\0' ? proc_p->auth_user : "-");
+		add_assoc_string(&fpm_proc_stat, "script", proc_p->script_filename[0] != '\0' ? proc_p->script_filename : "-");
+		add_assoc_double(&fpm_proc_stat, "last-request-cpu", proc_p->request_stage == FPM_REQUEST_ACCEPTING ? cpu : 0.);
+		add_assoc_long(&fpm_proc_stat, "last-request-memory", proc_p->request_stage == FPM_REQUEST_ACCEPTING ? proc_p->memory : 0);
 		add_next_index_zval(&fpm_proc_stats, &fpm_proc_stat);
 	}
 	add_assoc_zval(status, "procs", &fpm_proc_stats);
-	efree(procs);
+
+	fpm_scoreboard_free_copy(scoreboard_p);
 
 	return 0;
 }
diff '--color=auto' -Naur a/sapi/fpm/tests/bug74083-concurrent-reload.phpt b/sapi/fpm/tests/bug74083-concurrent-reload.phpt
--- a/sapi/fpm/tests/bug74083-concurrent-reload.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/sapi/fpm/tests/bug74083-concurrent-reload.phpt	2025-11-18 21:43:27.199378213 +0000
@@ -4,6 +4,7 @@
 <?php
 include "skipif.inc";
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
+if (getenv("GITHUB_ACTIONS") && PHP_OS_FAMILY === "Darwin") die("skip Potential cause for GitHub Actions crash");
 ?>
 --FILE--
 <?php
diff '--color=auto' -Naur a/sapi/fpm/tests/bug76601-reload-child-signals.phpt b/sapi/fpm/tests/bug76601-reload-child-signals.phpt
--- a/sapi/fpm/tests/bug76601-reload-child-signals.phpt	2025-10-21 19:23:55.000000000 +0000
+++ b/sapi/fpm/tests/bug76601-reload-child-signals.phpt	2025-11-18 21:43:27.199533767 +0000
@@ -4,6 +4,7 @@
 <?php
 include "skipif.inc";
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
+if (getenv("GITHUB_ACTIONS") && PHP_OS_FAMILY === "Darwin") die("skip Potential cause for GitHub Actions crash");
 ?>
 --FILE--
 <?php
diff '--color=auto' -Naur a/win32/select.c b/win32/select.c
--- a/win32/select.c	2025-10-21 19:23:55.000000000 +0000
+++ b/win32/select.c	2025-11-18 21:43:27.199673911 +0000
@@ -62,8 +62,10 @@
 	/* build an array of handles for non-sockets */
 	for (i = 0; (uint32_t)i < max_fd; i++) {
 		if (SAFE_FD_ISSET(i, rfds) || SAFE_FD_ISSET(i, wfds) || SAFE_FD_ISSET(i, efds)) {
-			handles[n_handles] = (HANDLE)(uintptr_t)_get_osfhandle(i);
-			if (handles[n_handles] == INVALID_HANDLE_VALUE) {
+			int _type;
+			int _len = sizeof(_type);
+
+			if (getsockopt((SOCKET)i, SOL_SOCKET, SO_TYPE, (char*)&_type, &_len) == 0 || WSAGetLastError() != WSAENOTSOCK) {
 				/* socket */
 				if (SAFE_FD_ISSET(i, rfds)) {
 					FD_SET((uint32_t)i, &sock_read);
@@ -78,8 +80,11 @@
 					sock_max_fd = i;
 				}
 			} else {
-				handle_slot_to_fd[n_handles] = i;
-				n_handles++;
+				handles[n_handles] = (HANDLE)(uintptr_t)_get_osfhandle(i);
+				if (handles[n_handles] != INVALID_HANDLE_VALUE) {
+					handle_slot_to_fd[n_handles] = i;
+					n_handles++;
+				}
 			}
 		}
 	}
